import {
  Component,
  ViewChild,
  ViewEncapsulation,
  OnInit,
  ElementRef,
  AfterViewInit,
  Renderer2,
} from '@angular/core';
import {
  DiagramComponent,
  // ZoomToOptions,
  LineDistribution,
  DiagramTooltipModel,
  DiagramConstraints,
  ConnectorConstraints,
} from '@syncfusion/ej2-angular-diagrams';
import html2canvas from 'html2canvas';
import download from 'downloadjs';
// import download from 'downloadjs';

// import html2canvas from 'html2canvas';


// import { TooltipModule } from '@syncfusion/ej2-angular-diagrams';
// import * as htmlToImage from 'html-to-image';
// import { toPng, toJpeg, toBlob, toPixelData, toSvg } from 'html-to-image';
import {
  NodeModel,
  ConnectorModel,
  DiagramTools,
  Diagram,
  DataBinding,
  ComplexHierarchicalTree,
  SnapConstraints,
  SnapSettingsModel,
  LayoutModel,
  LayoutOrientation,
  ConnectionPointOrigin,
  IDropEventArgs,
  IExportOptions,
  FileFormats,
  NodeConstraints,
  PrintAndExport,
  // TemplateModel
} from '@syncfusion/ej2-diagrams';
import { DataManager } from '@syncfusion/ej2-data';
import { ChangeEventArgs as NumericChangeEventArgs } from '@syncfusion/ej2-inputs';
import { ChangeEventArgs as CheckBoxChangeEventArgs } from '@syncfusion/ej2-buttons';
import { TitleStrategy } from '@angular/router';
import {
  Tooltip,
  TooltipModel,
  TooltipEventArgs,
} from '@syncfusion/ej2-angular-popups';
// import {ZoomTool}  from '@syncfusion/ej2-diagrams';
// import { NzTooltipDirective } from 'ng-zorro-antd/tooltip';

import * as svgExport from '@syncfusion/ej2-svg-base';
import { saveAs } from 'file-saver';
import _ from 'lodash';


Diagram.Inject(DataBinding, ComplexHierarchicalTree, LineDistribution);
Diagram.Inject(PrintAndExport);
export interface DataInfo {
  [key: string]: string;
}

@Component({
  selector: 'app-sync-chart',
  templateUrl: './sync-chart.component.html',
  styleUrls: ['./sync-chart.component.css']
})
export class SyncChartComponent {
  @ViewChild('diagram')
  public diagram: any;
  @ViewChild('screen') screen: ElementRef;
  @ViewChild('canvas') canvas: ElementRef;
  @ViewChild('downloadLink') downloadLink: ElementRef;
  // public tooltip?: DiagramTooltipModel;
  // public constraints?: NodeConstraints;

  public Data: any = [
    {
      title: 'Node 114',
      isExpandedChild: true,
      address: 'Gurgaon,Haryana',
      Name: 'node114',
      ReportingPerson: ['node11', 'node21', 'node31'],
      isRoot: false,
      fillColor: '#f3904a',
      border: '#d3722e',
    },
    {
      title: 'Node 1',
      isExpandedChild: true,
      address: 'Gurgaon,Haryana',
      Name: 'node1',
      isRoot: true,
      fillColor: '#e7704c',
      border: '#c15433',
    },
    {
      title: 'Node 11',
      isExpandedChild: true,
      address: 'Gurgaon,Haryana',
      Name: 'node11',
      ReportingPerson: ['node1'],
      isRoot: false,
      fillColor: '#e7704c',
      border: '#c15433',
    },
    {
      title: 'Node 12',
      isExpandedChild: true,
      address: 'Gurgaon,Haryana',
      Name: 'node12',
      ReportingPerson: ['node114'],
      isRoot: false,
      fillColor: '#efd46e',
      border: '#d6b123',
    },
    {
      title: 'Node 13',
      isExpandedChild: true,
      address: 'Gurgaon,Haryana',
      Name: 'node13',
      ReportingPerson: ['node12'],
      isRoot: false,
      fillColor: '#58b087',
      border: '#16955e',
    },
    {
      title: 'Node 14',
      isExpandedChild: true,
      address: 'Gurgaon,Haryana',
      Name: 'node14',
      ReportingPerson: ['node12'],
      isRoot: false,
      fillColor: '#58b087',
      border: '#16955e',
    },
    {
      title: 'Node 15',
      isExpandedChild: true,
      address: 'Gurgaon,Haryana',
      Name: 'node15',
      ReportingPerson: ['node12'],
      isRoot: false,
      fillColor: '#58b087',
      border: '#16955e',
    },
    {
      title: 'Node 16',
      isExpandedChild: true,
      address: 'Gurgaon,Haryana',
      Name: 'node16',
      ReportingPerson: [],
      isRoot: false,
      fillColor: '#14ad85',
    },
    {
      title: 'Node 17',
      isExpandedChild: true,
      address: 'Gurgaon,Haryana',
      Name: 'node17',
      ReportingPerson: ['node13', 'node14', 'node15'],
      isRoot: false,
      fillColor: '#659be5',
      border: '#3a6eb5',
    },
    {
      title: 'Node 18',
      isExpandedChild: true,
      address: 'Gurgaon,Haryana',
      Name: 'node18',
      ReportingPerson: [],
      isRoot: false,
      fillColor: '#14ad85',
    },
    {
      title: 'Node 19',
      isExpandedChild: true,
      address: 'Gurgaon,Haryana',
      Name: 'node19',
      ReportingPerson: ['node16', 'node17', 'node18'],
      isRoot: false,
      fillColor: '#8dbe6c',
      border: '#489911',
    },
    {
      title: 'Node 116',
      isExpandedChild: true,
      address: 'Gurgaon,Haryana',
      Name: 'node116',
      ReportingPerson: ['node22', 'node12'],
      isRoot: false,
      fillColor: '#58b087',
      border: '#16955e',
    },
    {
      title: 'Node 110',
      isExpandedChild: true,
      address: 'Gurgaon,Haryana',
      Name: 'node110',
      ReportingPerson: ['node16', 'node17', 'node18'],
      isRoot: false,
      fillColor: '#8dbe6c',
      border: '#489911',
    },
    {
      title: 'Node 111',
      isExpandedChild: true,
      address: 'Gurgaon,Haryana',
      Name: 'node111',
      ReportingPerson: ['node16', 'node17', 'node18', 'node116'],
      isRoot: false,
      fillColor: '#8dbe6c',
      border: '#489911',
    },
    // {
    //   title: 'Node 21',
    //   isExpandedChild: true,
    //   address: 'Gurgaon,Haryana',
    //   Name: 'node21',
    //   fillColor: '#e7704c',
    //   border: '#c15433',
    // },
    {
      title: 'Node 22',
      isExpandedChild: true,
      address: 'Gurgaon,Haryana',
      Name: 'node22',
      ReportingPerson: ['node114'],
      isRoot: false,
      fillColor: '#efd46e',
      border: '#d6b123',
    },
    {
      title: 'Node 23',
      isExpandedChild: true,
      address: 'Gurgaon,Haryana',
      Name: 'node23',
      ReportingPerson: ['node22'],
      isRoot: false,
      fillColor: '#58b087',
      border: '#16955e',
    },
    {
      title: 'Node 24',
      isExpandedChild: true,
      address: 'Gurgaon,Haryana',
      Name: 'node24',
      ReportingPerson: ['node22'],
      isRoot: false,
      fillColor: '#58b087',
      border: '#16955e',
    },
    {
      title: 'Node 25',
      isExpandedChild: false,
      address: 'Gurgaon,Haryana',
      Name: 'node25',
      // ReportingPerson: ['node22'],
      isRoot: false,
      fillColor: '#58b087',
      border: '#16955e',
    },
    {
      title: 'Node 26',
      isExpandedChild: true,
      address: 'Gurgaon,Haryana',
      Name: 'node26',
      ReportingPerson: [],
      isRoot: false,
      fillColor: '#14ad85',
    },
    {
      title: 'Node 27',
      isExpandedChild: true,
      address: 'Gurgaon,Haryana',
      Name: 'node27',
      ReportingPerson: ['node23', 'node24', 'node25'],
      isRoot: false,
      fillColor: '#659be5',
      border: '#3a6eb5',
    },
    {
      title: 'Node 28',
      isExpandedChild: true,
      address: 'Gurgaon,Haryana',
      Name: 'node28',
      ReportingPerson: [],
      isRoot: false,
      fillColor: '#14ad85',
    },
    {
      title: 'Node 29',
      isExpandedChild: true,
      address: 'Gurgaon,Haryana',
      Name: 'node29',
      ReportingPerson: ['node26', 'node27', 'node28', 'node116'],
      isRoot: false,
      fillColor: '#8dbe6c',
      border: '#489911',
    },
    {
      title: 'Node 210',
      isExpandedChild: true,
      address: 'Gurgaon,Haryana',
      Name: 'node210',
      ReportingPerson: ['node26', 'node27', 'node28'],
      isRoot: false,
      fillColor: '#8dbe6c',
      border: '#489911',
    },
    {
      title: 'Node 211',
      isExpandedChild: true,
      address: 'Gurgaon,Haryana',
      Name: 'node211',
      ReportingPerson: ['node26', 'node27', 'node28'],
      isRoot: false,
      fillColor: '#8dbe6c',
      border: '#489911',
    },
  ];

  public constraints = DiagramConstraints.Default | DiagramConstraints.Tooltip;

  tooltip: any = {
    position: 'TopCenter',
    relativeMode: 'Object',
    animation: {
      open: { effect: 'FadeZoomIn', delay: 100 },
      close: { effect: 'FadeZoomOut', delay: 100 },
    },
  };

  constructor(private elementRef: ElementRef, private renderer: Renderer2) {}
  ngOnInit() {
    console.log('ini');
    //   this.tooltip = {
    //     //Sets the content of the Tooltip
    //     content: 'Node1',
    //     //Sets the position of the Tooltip
    //     position: 'BottomRight',
    //     //Sets the tooltip position relative to the node
    //     relativeMode: 'Object'
    // }
    // this.constraints = NodeConstraints.Default | NodeConstraints.Tooltip
    // this.tooltip = {
    //   enable: true, // Enable tooltips globally
    //   type: ['Node'],
    //   content: 'ABC',
    //   // Show tooltips for nodes
    //   // Additional customization options:
    //   // content: string, // Define a default content for tooltips
    //   // position: string, // Set tooltip position (e.g., 'Top', 'Bottom', 'Right', 'Left')
    //   // relativeMode: boolean, // Show tooltip relative to node or mouse position
    // };

    // this.constraints = NodeConstraints.Default | NodeConstraints.Tooltip
    // this.expandToNode('node31')
  }

  ngAfterViewInit() {
   
    // ... (existing initialization code)

    // const zoomTool = new ZoomTool();
    // this.diagram.addTool(zoomTool);
    const diagramElement = this.diagram.element;
    console.log('ele : ', diagramElement);
  }

  public nodeDefaults(obj: NodeModel): NodeModel {
    console.log('obj : ', obj);
    obj.width = 250;
    if (
      (obj as any).data.S_LOCATION_ID == '' ||
      (obj as any).data.S_CREATION_OPERATION_ID == ''
    ) {
      obj.height = 180;
    } else obj.height = 200;
    //Initialize shape
    obj.constraints =
      (NodeConstraints.Default &
        ~(
          NodeConstraints.Rotate |
          NodeConstraints.Select |
          NodeConstraints.Drag |
          NodeConstraints.Resize
        )) |
      NodeConstraints.Tooltip;

    let htmlNodeContent = `
    <div class="tooltip-container">
    <div class="tooltip-image">
      <img
        src="../../assets/images/.svg"
      />
    </div>
    <div class="tooltip-content">
      <div class="content-header">
        <div>Sample:  ${(obj as any).data.title}</div>
        <div>Location : ${(obj as any).data.Name}</div>
      </div>
      <div class="address">
      </div>
      <div class="cell-tag" id="cellLineTooltip_${obj.id}">
        <img
          class="cell-tag-image"
        src="../../assets/images/.svg"
        />
        <span class="cell-tag-text">Cell Line</span>
      </div>
      </div>
    </div>
  </div>
  `;

    obj.shape = {
      // content: htmlNodeContent,
      // type: 'HTML',
      // shape: 'Rectangle',
      // cornerRadius: 7,
    };
    // addInfo: {
    //   template: '<div style="width: 100px; height: 50px; text-align: center; line-height: 50px; color: white; font-size: 14px; border-radius: 5px;"></div>'
    // }

    let tooltipContent = `
    <div style="border: 1px solid #ccc; background-color: white; padding: 5px;">
              <div><strong>Name:</strong> ${(obj as any).data.title}</div>
              <div><strong>ID:</strong> ${(obj as any).data.Name}</div>
          </div>
    `;
    // obj.constraints = NodeConstraints.Default | NodeConstraints.Tooltip;
    obj.tooltip.content = tooltipContent;
    obj.tooltip.position = 'TopRight';
    obj.tooltip.relativeMode = 'Object';

    obj.expandIcon = {
      shape: 'Minus',
    };
    obj.collapseIcon = {
      shape: 'Plus',
    };
    // console.log('obj :', obj);
    return obj;
  }

  public data: Object = {
    id: 'Name',
    parentId: 'ReportingPerson',
    dataSource: new DataManager(this.Data),
    //binds the external data with node
    doBinding: (nodeModel: NodeModel, data: DataInfo, diagram: Diagram) => {
      console.log('data : ', data, diagram, nodeModel);
      /* tslint:disable:no-string-literal */
      nodeModel.style = {
        fill: data['fillColor'],
        strokeWidth: 1,
        strokeColor: data['border'],
      };
    },
  };

  public created(): void {
    // this.diagram.setNodeTemplate(this.getNodeTemplate.bind(this));

    this.ensureVisibleNode('node25');
    const zoomOptions: any = {
      zoomFactor: 0, // 100% zoom (initial)
      zoomPosition: { x: 0, y: 0 }, // Center the content
    };
    this.diagram.zoomTo({ type: 'ZoomOut' });
    // this.diagram.scrollSettings.currentZoom = 1.0;
    // this.diagram.scrollSettings.horizontalOffset = 0;
    // this.diagram.scrollSettings.verticalOffset = 0;
    // console.log("dta : ", this.diagram, this.diagram.nodes);
    //   for(var i=0;i<this.diagram.nodes.length;i++){
    //     // console.log("each : ",this.diagram.nodes[i])
    //     // console.log("value : ", this.diagram.nodes[i].data['title']
    //     // );
    //     this.diagram.nodes[i].isExpanded= this.diagram.nodes[i].data['isExpandedChild'];
    //  }
    // this.collapseNode('node114');
    this.diagram.fitToPage();
    this.diagram.dataBind();
    // doLayout is used to rearrange the nodes and connectors in diagram
    this.diagram.doLayout();

    // console.log("crated : ", this.diagram)
    this.expandToNode('node114');
  }

  // Method to collapse a specific node and its children recursively
  public collapseNode(nodeId: string): void {
    let diagram: Diagram = this.diagram;
    let node: NodeModel = diagram.getObject(nodeId);
    // console.log("node collaspse : ", node, diagram);

    if (node) {
      this.collapseRecursive(node);
    }
  }

  private collapseRecursive(node: NodeModel): void {
    let diagram: Diagram = this.diagram;
    // diagram.collapse(node);
    // node.outEdges.forEach((connector: string) => {
    //     let childNode: NodeModel = diagram.getObject(diagram.connectors[connector].targetID);
    //     if (childNode) {
    //         this.collapseRecursive(childNode);
    //     }
    // });
  }

  public connDefaults(connector: ConnectorModel): void {
    connector.type = 'Orthogonal';
    connector.constraints =
      ConnectorConstraints.Default |
      (ConnectorConstraints.Tooltip &
        ~(
          ConnectorConstraints.Select |
          ConnectorConstraints.Interaction |
          ConnectorConstraints.ReadOnly
        ));
    connector.cornerRadius = 7;
    connector.targetDecorator.height = 7;
    connector.targetDecorator.width = 7;
    connector.targetDecorator.shape = `OpenArrow`;
    connector.targetDecorator.style.fill = '#52247F';
    connector.targetDecorator.style.strokeColor = '#52247F';
    connector.style.strokeColor = '#C9BBD7';
    // box-shadow: 0px 1px 1px 0px #52247F1A;
  }

  public tool: DiagramTools = DiagramTools.ZoomPan;

  public snapSettings: SnapSettingsModel = {
    // console.log("snapSetting");
    constraints: SnapConstraints.None,
  };

  public layout: LayoutModel = {
    type: 'ComplexHierarchicalTree',
    connectionPointOrigin: ConnectionPointOrigin.DifferentPoint,
    horizontalSpacing: 70,
    verticalSpacing: 70,
    orientation: 'TopToBottom',
    margin: { left: 10, right: 0, top: 50, bottom: 0 },
  };

  public drop(args: IDropEventArgs) {
    //Argument element is used to get the dropped node.
    let node: NodeModel = args.element as NodeModel;
    //Gets the connector that connected to dropped node
    let edges: string[] = this.diagram.getEdges(node);
    let connector: ConnectorModel = this.diagram.getObject(edges[0]);
    //Argument target is used to get the hovered node
    connector.sourceID = (args.target as NodeModel).id;
    this.diagram.dataBind();
    // doLayout is used to rearrange the nodes and connectors in diagram
    this.diagram.doLayout();
  }

  ensureVisibleNode(nodeId: string) {
    console.log('sss : ', nodeId);

    const nodeElement = document.getElementById(nodeId); // Assuming unique IDs
    let currentNode: any;
    for (var i = 0; i < this.diagram.nodes.length; i++) {
      // console.log("each : ",this.diagram.nodes[i])
      // console.log("value : ", this.diagram.nodes[i].data['title']
      // );
      if (this.diagram.nodes[i].data['Name'] == nodeId) {
        currentNode = this.diagram.nodes[i];
        console.log('cuurent : ', currentNode);
        // currentNode.visible = false;
        this.diagram.nodes[i].isExpanded = false;
      }
      // this.diagram.nodes[i].isExpanded= this.diagram.nodes[i].data['isExpandedChild'];
    }
    // if (nodeElement) {
    //   const nodeRect = nodeElement.getBoundingClientRect(); // Get DOM element's rectangle

    //   // Check if the node is partially or completely outside the visible area
    //   const isPartiallyVisible = nodeRect.top < 0 ||
    //                              nodeRect.left < 0 ||
    //                              nodeRect.bottom > window.innerHeight ||
    //                              nodeRect.right > window.innerWidth;

    //   if (isPartiallyVisible) {
    //     // Calculate necessary scroll offsets based on diagram container element
    //     const diagramContainer = this.diagram.element; // Assuming reference to container
    //     const scrollX = nodeRect.left < 0 ? nodeRect.left : 0;
    //     const scrollY = nodeRect.top < 0 ? nodeRect.top : 0;

    //     // Adjust scroll position of the diagram container element
    //     diagramContainer.scrollTop += scrollY;
    //     diagramContainer.scrollLeft += scrollX;
    //   }
    // }
  }

  // expandstateChange(event) {
  //   console.log('expnad', event);
  //   let currentCollapseNodeName = event.element.data.Name;
  //   console.log('current : Node : ', currentCollapseNodeName);

  //   //nodes collapsed
  //   if (!event.state) {
  //     let nodeHiddenByCollapse: any;
  //     for (var i = 0; i < this.diagram.nodes.length; i++) {
  //       // console.log('each : ', this.diagram.nodes[i]);
  //       let nodeElementData = this.diagram.nodes[i].properties.data;
  //       if (nodeElementData.ReportingPerson) {
  //         // console.log('found : ', nodeElementData);
  //         // console.log("ANS NDE :",nodeElementData.ReportingPerson.includes(currentCollapseNodeName), nodeElementData);
  //         if (
  //           nodeElementData.ReportingPerson.includes(currentCollapseNodeName)
  //         ) {
  //           // console.log('Final value : ', this.diagram.nodes[i]);
  //           if (this.diagram.nodes[i].visible) {
  //             this.diagram.nodes[i].visible = false;
  //             nodeHiddenByCollapse = this.diagram.nodes[i];

  //             // this.diagram.nodes[i].isExpanded = false;
  //           }
  //         }
  //       }
  //     }

  //     console.log('collasped hidden node : ', nodeHiddenByCollapse);

  //     if(nodeHiddenByCollapse){
  //     let nodeHiddenByCollapseReportingPersons  = nodeHiddenByCollapse.properties.data.ReportingPerson
  //     nodeHiddenByCollapseReportingPersons.forEach((d)=>{
  //       if(d != currentCollapseNodeName){
  //         for (var i = 0; i < this.diagram.nodes.length; i++){
  //           let nodeElementData = this.diagram.nodes[i].properties.data;
  //           let nodeParent = nodeElementData.ReportingPerson;
  //           if(nodeElementData.Name == d){
  //             this.diagram.nodes[i].visible = false;
  //             this.diagram.nodes[i].isExpanded = false;
  //           }
  //         }
  //       }
  //     })
  //   }
     
  //   }
  //   else {
  //     console.log("else");

  //     let nodeHiddenWhenExpanded : any;
  //     for (var i = 0; i < this.diagram.nodes.length; i++) {
  //       // console.log('each : ', this.diagram.nodes[i]);
  //       let nodeElementData = this.diagram.nodes[i].properties.data;
  //       if (nodeElementData.ReportingPerson) {
  //         if (
  //           nodeElementData.ReportingPerson.includes(currentCollapseNodeName)
  //         ) {

  //           if(nodeElementData.ReportingPerson.length > 1){
  //             console.log("found parent new : ", this.diagram.nodes[i]);
  //             nodeHiddenWhenExpanded = this.diagram.nodes[i];
  //           }
  //           console.log('Final value : ', this.diagram.nodes[i]);
  //           if (this.diagram.nodes[i].visible) {
  //             this.diagram.nodes[i].visible = true;
  //             // nodeHiddenByCollapse = this.diagram.nodes[i];

  //             // this.diagram.nodes[i].isExpanded = false;
  //           }
  //         }
  //       }
  //     }
  //     if(nodeHiddenWhenExpanded){
  //       let nodeHiddenWhenExpandedReportingPersons  = nodeHiddenWhenExpanded.properties.data.ReportingPerson
  //       nodeHiddenWhenExpandedReportingPersons.forEach((d)=>{
  //         if(d != currentCollapseNodeName){
  //           for (var i = 0; i < this.diagram.nodes.length; i++){
  //             let nodeElementData = this.diagram.nodes[i].properties.data;
  //             let nodeParent = nodeElementData.ReportingPerson;
  //             if(nodeElementData.Name == d){
  //               this.diagram.nodes[i].visible = true;
  //               this.diagram.nodes[i].isExpanded = true;
  //             }
  //           }
  //         }
  //       })
  //     }
  //   }
  // }

  expandstateChange(event) {
    console.log('expnad', event);
    let currentCollapseNodeName = event.element.data.Name;
    console.log('current : Node : ', currentCollapseNodeName);

    //nodes collapsed
    if (!event.state) {
      let nodeHiddenByCollapse: any;
      for (var i = 0; i < this.diagram.nodes.length; i++) {
        // console.log('each : ', this.diagram.nodes[i]);
        let nodeElementData = this.diagram.nodes[i].properties.data;
        if (nodeElementData.ReportingPerson) {
          // console.log('found : ', nodeElementData);
          // console.log("ANS NDE :",nodeElementData.ReportingPerson.includes(currentCollapseNodeName), nodeElementData);
          if (
            nodeElementData.ReportingPerson.includes(currentCollapseNodeName)
          ) {
            // console.log('Final value : ', this.diagram.nodes[i]);
            if (this.diagram.nodes[i].visible) {
              this.diagram.nodes[i].visible = false;
              nodeHiddenByCollapse = this.diagram.nodes[i];

              // this.diagram.nodes[i].isExpanded = false;
            }
          }
        }
      }

      console.log('collasped hidden node : ', nodeHiddenByCollapse);

      if(nodeHiddenByCollapse){
      let nodeHiddenByCollapseReportingPersons  = nodeHiddenByCollapse.properties.data.ReportingPerson
      nodeHiddenByCollapseReportingPersons.forEach((d)=>{
        if(d != currentCollapseNodeName){


          for (var i = 0; i < this.diagram.nodes.length; i++){
            let nodeElementData = this.diagram.nodes[i].properties.data;
            let nodeParent = nodeElementData.ReportingPerson;
            if(nodeElementData.Name == d){
              //check if node if linked with any upper parent
              console.log("Doe -- > ", this.diagram.nodes[i]);
              if(nodeElementData.ReportingPerson &&    nodeElementData.ReportingPerson.length>0 )
              // this.diagram.nodes[i].visible = false;
              this.diagram.nodes[i].isExpanded = false;

              else {
              this.diagram.nodes[i].visible = false;
              this.diagram.nodes[i].isExpanded = false;

              }
            }
          }
        }
      })
    }
     
    }
    else {
      console.log("else");

      let nodeHiddenWhenExpanded : any;
      for (var i = 0; i < this.diagram.nodes.length; i++) {
        // console.log('each : ', this.diagram.nodes[i]);
        let nodeElementData = this.diagram.nodes[i].properties.data;
        if (nodeElementData.ReportingPerson) {
          if (
            nodeElementData.ReportingPerson.includes(currentCollapseNodeName)
          ) {

            if(nodeElementData.ReportingPerson.length > 1){
              console.log("found parent new : ", this.diagram.nodes[i]);
              nodeHiddenWhenExpanded = this.diagram.nodes[i];
            }
            console.log('Final value : ', this.diagram.nodes[i]);
            if (this.diagram.nodes[i].visible) {
              this.diagram.nodes[i].visible = true;
              // nodeHiddenByCollapse = this.diagram.nodes[i];

              // this.diagram.nodes[i].isExpanded = false;
            }
          }
        }
      }
      if(nodeHiddenWhenExpanded){
        let nodeHiddenWhenExpandedReportingPersons  = nodeHiddenWhenExpanded.properties.data.ReportingPerson
        nodeHiddenWhenExpandedReportingPersons.forEach((d)=>{
          if(d != currentCollapseNodeName){
            for (var i = 0; i < this.diagram.nodes.length; i++){
              let nodeElementData = this.diagram.nodes[i].properties.data;
              let nodeParent = nodeElementData.ReportingPerson;
              if(nodeElementData.Name == d){
                this.diagram.nodes[i].visible = true;
                this.diagram.nodes[i].isExpanded = true;
              }
            }
          }
        })
      }
    }
  }

  // this.expandToNode('child');

  // Method to expand nodes until reaching a particular node
  public expandToNode(nodeId: string) {
    const node = this.diagram;
    // getObject(nodeId) as NodeModel;
    console.log('node : ', node);

    // const node = this.diagram.diagram.getObject(nodeId) as NodeModel;
    // if (node) {
    //   this.expandNode(nodeId);
    //   if (node.parents) {
    //     for (const parentId of node.parents) {
    //       this.expandToNode(parentId);
    //     }
    //   }
    // }
  }

  // Method to expand a specific node
  private expandNode(nodeId: string) {
    // this.diagram.diagram.expandNode(nodeId);
  }

  public export() {
    console.log('click');

    // this.diagram.nodes.forEach((node: NodeModel) => {
    //   node.annotations = [{ content: node.customTextContent }];
    // });

    let exportOptions: IExportOptions = {};
    exportOptions.format = 'SVG' as FileFormats;
    exportOptions.mode = 'Download';
    exportOptions.region = 'Content';
    exportOptions.multiplePage = false;
    exportOptions.fileName = 'MultiparentTree';
    // console.log("this.d : ", this.diagram, exportOptions);

    this.diagram.exportDiagram(exportOptions);
  }

  public onTooltipRender(event: any) {
    console.log('render : ', event);
  }

  public downloadImage() {
    let svgBoundary = document.getElementById('diagram_backgroundLayer_svg');
    let elmContainer = document.getElementById('diagramcontent');

    let elmWidth = elmContainer.getBoundingClientRect().width;
    let elmheight = elmContainer.getBoundingClientRect().height;

    console.log('download image svg height : ', svgBoundary);
    console.log('DDDD : ', svgBoundary.getBoundingClientRect());
    let svgHeight = svgBoundary.getBoundingClientRect().height;
    let svgWidth = svgBoundary.getBoundingClientRect().width;

    console.log('ans : ', svgHeight, svgWidth);

    // while (elmheight <= svgHeight) {
    //   this.diagram.zoomTo({ type: 'ZoomOut', zoomFactor: 1 });
    //   console.log('loop : ', svgBoundary);
    //   console.log('height : ', svgWidth);
    //   svgHeight = svgBoundary.getBoundingClientRect().height;
    //   svgWidth = svgBoundary.getBoundingClientRect().width;
    // }

    // this.diagram.zoomTo({type: "ZoomOut" ,zoomFactor:1});
    // console.log("native : ", this.screen.nativeElement);
    // document.getElementById('chart-id').scrollTop = document.getElementById('chart-id').offsetTop -10;
    //  html2canvas(this.screen.nativeElement,{scrollY: -document.getElementById('chart-id').offsetTop}).then(canvas => {
    //    console.log("this.canvas : ", this.canvas);

    //     this.canvas.nativeElement.src = canvas.toDataURL();
    //     this.downloadLink.nativeElement.href = canvas.toDataURL('image/png');
    //     this.downloadLink.nativeElement.download = 'lineage-chart.png';
    //     this.downloadLink.nativeElement.click();
    //     this.canvas.nativeElement.src = null;
    //     this.downloadLink.nativeElement.href ="";
    //   });

    html2canvas(document.getElementById('diagramcontent')).then((canvas) => {
      console.log('this.canvas : ', this.canvas);
      var anchorTag = document.createElement('a');
      document.body.appendChild(anchorTag);
      document.getElementById('previewImg').appendChild(canvas);
      anchorTag.download = 'filename.jpg';
      anchorTag.href = canvas.toDataURL();
      anchorTag.target = '_blank';
      anchorTag.click();
    });
  }

  htmlToPNG() {
    console.log('found');

    // const saveAs = (blob) => {
    //   var elem = window.document.createElement('a');
    //   console.log("ddd : ", elem);

    //   elem.href = blob;
    //   const fileName = 'Geeta.png';
    //   elem.download = fileName;
    //   (document.body || document.documentElement).appendChild(elem);
    //   console.log("elem : " ,elem);

    //   if (typeof elem.click === 'function') {
    //     elem.click();
    //   } else {
    //     elem.target = '_blank';
    //     elem.dispatchEvent(
    //       new MouseEvent('click', {
    //         view: window,
    //         bubbles: true,
    //         cancelable: true,
    //       })
    //     );
    //   }
    //   URL.revokeObjectURL(elem.href);
    //   elem.remove();
    //   // this.isLoading = false;
    // };

    // htmlToImage
    //   .toPng(document.getElementById('chart-id'))
    //   .then(function (dataUrl) {
    //     saveAs(dataUrl);
    //   });

    console.log('con : ', document.getElementById('diagram'));

    // htmlToImage
    //   .toPng(document.getElementById('diagram'))
    //   .then(function (dataUrl) {
    //     console.log('daa : ', dataUrl);

    //     download(dataUrl, 'my-node.png');
    //   });
  }

  public zoomIn() {
    console.log('in zoom');
    this.diagram.zoomTo({ type: 'ZoomIn' });
  }

  public zoomOut() {
    console.log('out zoom ');
    // this.diagram.z
    this.diagram.zoomTo({ type: 'ZoomOut' });
  }


  exportDiagram(): void {

    let ans = [];
    this.diagram.nodes.forEach((d)=>{
      // ans.push(d.id);
      ans.push(document.querySelectorAll(`.tooltip-container`))
    })
    console.log("ans : ", ans);
    
    const nodes = document.querySelectorAll('.node-html'); // Assuming nodes have a class 'node-html'

    ans.forEach(node => {
      // const htmlContent:any = node.querySelector('.html-content');
      if (node) {
        this.convertHTMLToImage(node).then(imageData => {
          node.innerHTML = `<img src="${imageData}" />`;
        }).catch(error => {
          console.error('Error converting HTML to image:', error);
        });
      }
    });

    let exportOptions: IExportOptions = {};
    exportOptions.format = 'SVG' as FileFormats;
    exportOptions.mode = 'Download';
    exportOptions.region = 'Content';
    exportOptions.multiplePage = false;
    exportOptions.fileName = 'MultiparentTree';
    // console.log("this.d : ", this.diagram, exportOptions);

    this.diagram.exportDiagram(exportOptions);
    // Now you can export the diagram using Syncfusion's export functionality
    // Make sure to trigger the export operation after converting HTML content to images
  }


   // Convert HTML content to image using html2canvas library
   convertHTMLToImage(htmlContent: HTMLElement): Promise<string> {
     console.log("ht : ", htmlContent);
     
    return html2canvas(htmlContent).then(canvas => {
      console.log("htmlConet : ", htmlContent);
      
      return canvas.toDataURL('image/png');
    });
  }

  newExport(){
      const svgContent = this.diagram.exportDiagram({ mode: 'Data' });
      console.log("svgCon : ", svgContent);
      
      const div = document.createElement('div');
      div.innerHTML = svgContent;
      const svgNode = div.firstChild;
      
      if (svgNode instanceof Node) {
        const serializer = new XMLSerializer();
        const svgString = serializer.serializeToString(svgNode);
        const blob = new Blob([svgString], { type: 'image/svg+xml' });
        saveAs(blob, 'diagram.svg');
      } else {
        console.error('Failed to export diagram: SVG content is invalid.');
      }
    }
  
}

